
#include <stdlib.h>
#include <stdio.h>
#include <ctype.h>

int
getmemorysize()
{
    FILE *ff;
    int m = -1;
    char *p;
    char buf[80];

    if (!(ff = fopen("/proc/meminfo", "r")))
	return m;
    while (fgets(buf, sizeof(buf)-1, ff)) {
	if (!strncmp("MemTotal:", buf, strlen("MemTotal:"))) {
	    p = buf;
	    while (*p && !isspace(*p))
		p++;
	    while (isspace(*p))
		p++;
	    m = atoi(p) * 1024;
	    break;
	}
    }
    fclose(ff);
    return m;
}

main(
   int argc,
   char **argv )
{
    int n;
    char *p, *p2;

    n = getmemorysize();
    printf("memory size %d\n", n);
    if (n > 0)
	n = (n / 4) * 3 + 1;
    else
	n = 10000000;
    printf("allocate %d\n", n);
    if ((p = malloc(n))) {
	for (p2 = p; p2 - p < n; p2 += 4096)
	    *p2 = 0;
	free(p);
	n *= 2;
    }
}


